module lmdz_call_blowing_snow

contains

SUBROUTINE call_blowing_snow_sublim_sedim(ngrid,nlay,dtime,temp,q,qbs,pplay,paprs, &
                                  dtemp_bs,dq_bs,dqbs_bs,bsfl,precip_bs)

USE lmdz_blowing_snow_sublim_sedim, ONLY: blowing_snow_sublim_sedim
IMPLICIT NONE

!INPUT
!=====

INTEGER, INTENT(IN)                     :: ngrid,nlay
REAL, INTENT(IN)                        :: dtime
REAL, INTENT(IN), DIMENSION(ngrid,nlay) :: temp
REAL, INTENT(IN), DIMENSION(ngrid,nlay) :: q
REAL, INTENT(IN), DIMENSION(ngrid,nlay) :: qbs
REAL, INTENT(IN), DIMENSION(ngrid,nlay) :: pplay
REAL, INTENT(IN), DIMENSION(ngrid,nlay+1) :: paprs


! OUTPUT
!========


REAL, INTENT(OUT), DIMENSION(ngrid,nlay) :: dtemp_bs
REAL, INTENT(OUT), DIMENSION(ngrid,nlay) :: dq_bs
REAL, INTENT(OUT), DIMENSION(ngrid,nlay) :: dqbs_bs
REAL, INTENT(OUT), DIMENSION(ngrid,nlay+1) :: bsfl
REAL, INTENT(OUT), DIMENSION(ngrid)      :: precip_bs

      


CALL blowing_snow_sublim_sedim(ngrid,nlay,dtime,temp,q,qbs,pplay,paprs, &
                                  dtemp_bs,dq_bs,dqbs_bs,bsfl,precip_bs)





END SUBROUTINE  call_blowing_snow_sublim_sedim

end module lmdz_call_blowing_snow
